package org.mai.dep110.scala.iris

import PetalSize.PetalSize

import scala.io.Source
import scala.util.Try

object IrisExample extends App {

  val flowers = loadFromFile("iris.data")
  //println(flowers)

  //get average sepal width
  val avgSepalLength = 0.0
  println(avgSepalLength)

  //get average petal square - petal width multiplied on petal length
  val avgPetalLength = 0.0
  println(avgPetalLength)

  //get average petal square for flowers with sepal width > 4
  val avgPetalSquare = 0.0
  println(avgPetalSquare)

  //get flowers grouped by Petal size (PetalSize.Small, etc.) with function getPetalSize
  val groupsByPetalSize = Map()
  println(groupsByPetalSize)

  //get max sepal width for flowers grouped by species
  val maxSepalWidthForGroupsBySpecies = Map()
  println(maxSepalWidthForGroupsBySpecies)


  def loadFromFile(path: String): List[Iris] = {
    Source
      .fromFile(path)
      .getLines
      .map(line => line.toIris)
      .filter{
        case Some(iris) => true
        case None => false
      }
      .map{
        case Some(iris) => iris
      }
      .toList
  }

  implicit class StringToIris(str: String) {
    def toIris: Option[Iris] = str.split(",") match {
      case Array(a,b,c,d,e) if isDouble(a) && isDouble(b) && isDouble(c) && isDouble(d) =>
        Some(
          Iris(
            a.toDouble,
            b.toDouble,
            c.toDouble,
            d.toDouble,
            e))
      case others => None
    }

    def isDouble(str: String): Boolean = Try(str.toDouble).isSuccess
  }

  def getPetalSize(iris: Iris): PetalSize = {
    val petalSquare = iris.petalLength * iris.petalWidth
    if(petalSquare < 2.0)
      PetalSize.Small
    if(petalSquare < 5.0)
      PetalSize.Medium
    PetalSize.Large
  }

}

object PetalSize extends Enumeration {
  type PetalSize = Value
  val Large, Medium, Small = Value
}

case class Iris(sepalLength: Double, sepalWidth: Double, petalLength: Double, petalWidth: Double, species: String)
